#
# Conditional build:
%bcond_without	static_libs	# static libraries
%bcond_with	libatomic_ops	# use libatomic_ops instead of intrinsics

%ifarch i386 i486
%define	with_libatomic_ops	1
%endif
Summary:	The Boehm-Demers-Weiser conservative garbage collector
Summary(pl.UTF-8):	Konserwatywny odśmiecacz pamięci Boehma-Demersa-Weisera
Name:		gc
Version:	8.2.4
Release:	1%{?tld}
License:	BSD-like
Group:		Libraries
Source0:	https://www.hboehm.info/gc/gc_source/%{name}-%{version}.tar.gz
# Source0-md5:	8901a6ed29ac35842420054772ea3441
URL:		https://www.hboehm.info/gc/
BuildRequires:	autoconf >= 2.64
BuildRequires:	automake
%if %{with libatomic_ops}
BuildRequires:	libatomic_ops-devel >= 7.4.4
%endif
BuildRequires:	libstdc++-devel
BuildRequires:	libtool >= 2:2
%if %{with libatomic_ops}
Requires:	libatomic_ops >= 7.4.4
%endif
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
Gc is a conservative garbage collector for C and C++. It is used as a
replacement for standard malloc() and free(). GC_malloc will attempt
to reclaim inaccessible space automatically by invoking a conservative
garbage collector at appropriate points.

%description -l pl.UTF-8
Gc jest konserwatywnym odśmiecaczem pamięci dla C i C++. Jest używany
jako zamiennik dla standardowych funkcji malloc() i free(). GC_malloc
próbuje odzyskać niedostępna pamięć automatycznie przez wywoływanie
konserwatywnego odśmiecacza pamięci w odpowiednich miejscach.

%package devel
Summary:	Headers for conservative garbage collector
Summary(pl.UTF-8):	Nagłówki dla konserwatywnego odśmiecacza pamięci
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}
%if %{with libatomic_ops}
Requires:	libatomic_ops-devel >= 7.4.4
%endif

%description devel
Headers for conservative garbage collector

%description devel -l pl.UTF-8
Nagłówki dla konserwatywnego odśmiecacza pamięci

%package static
Summary:	Static version of gc library
Summary(pl.UTF-8):	Statyczna wersja biblioteki gc
Group:		Development/Libraries
Requires:	%{name}-devel = %{version}-%{release}

%description static
Static version of gc library

%description static -l pl.UTF-8
Statyczna wersja biblioteki gc

%package c++
Summary:	C++ interface to GC library
Summary(pl.UTF-8):	Interfejs C++ do biblioteki GC
Group:		Libraries
Requires:	%{name} = %{version}-%{release}

%description c++
C++ interface to GC library.

%description c++ -l pl.UTF-8
Interfejs C++ do biblioteki GC.

%package c++-devel
Summary:	Header files for C++ interface for GC library
Summary(pl.UTF-8):	Pliki nagłówkowe interfejsu C++ do biblioteki GC
Group:		Development/Libraries
Requires:	%{name}-c++ = %{version}-%{release}
Requires:	%{name}-devel = %{version}-%{release}
Requires:	libstdc++-devel

%description c++-devel
Header files for C++ interface for GC library.

%description c++-devel -l pl.UTF-8
Pliki nagłówkowe interfejsu C++ do biblioteki GC.

%package c++-static
Summary:	C++ interface to GC library - static library
Summary(pl.UTF-8):	Interfejs C++ do biblioteki GC - biblioteka statyczna
Group:		Development/Libraries
Requires:	%{name}-c++-devel = %{version}-%{release}

%description c++-static
C++ interface to GC library - static library.

%description c++-static -l pl.UTF-8
Interfejs C++ do biblioteki GC - biblioteka statyczna.

%prep
%setup -q

# don't install docs to %{_datadir}/%{name}
%{__perl} -pi -e 's/^dist_pkgdata_DATA/EXTRA_DIST/' doc/doc.am

%build
%{__libtoolize}
%{__aclocal}
%{__autoconf}
%{__automake}
%configure \
%ifnarch sparc64
	CPPFLAGS="%{rpmcppflags} -DUSE_LIBC_PRIVATES" \
%endif
	--enable-cplusplus \
	%{?with_static_libs:--enable-static} \
	--enable-threads=posix \
	--with-libatomic-ops%{!?with_libatomic_ops:=check}
%{__make}

%install
rm -rf $RPM_BUILD_ROOT

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

# packaged as %doc
%{__rm} -r $RPM_BUILD_ROOT%{_docdir}/gc
#install -D -p doc/gc.man $RPM_BUILD_ROOT%{_mandir}/man3/gc.3

%clean
rm -rf $RPM_BUILD_ROOT

%post   -p /sbin/ldconfig
%postun -p /sbin/ldconfig

%post   c++ -p /sbin/ldconfig
%postun c++ -p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%doc AUTHORS ChangeLog README.QUICK README.md doc/README.{cords,environment,linux,macros}
%attr(755,root,root) %{_libdir}/libcord.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libcord.so.1
%attr(755,root,root) %{_libdir}/libgc.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libgc.so.1

%files devel
%defattr(644,root,root,755)
%doc doc/*.md
%attr(755,root,root) %{_libdir}/libcord.so
%attr(755,root,root) %{_libdir}/libgc.so
%{_libdir}/libcord.la
%{_libdir}/libgc.la
%dir %{_includedir}/gc
%{_includedir}/gc/cord.h
%{_includedir}/gc/cord_pos.h
%{_includedir}/gc/ec.h
%{_includedir}/gc/gc.h
%{_includedir}/gc/gc_allocator.h
%{_includedir}/gc/gc_backptr.h
%{_includedir}/gc/gc_config_macros.h
%{_includedir}/gc/gc_disclaim.h
%{_includedir}/gc/gc_gcj.h
%{_includedir}/gc/gc_inline.h
%{_includedir}/gc/gc_mark.h
%{_includedir}/gc/gc_pthread_redirects.h
%{_includedir}/gc/gc_tiny_fl.h
%{_includedir}/gc/gc_typed.h
%{_includedir}/gc/gc_version.h
%{_includedir}/gc/javaxfc.h
%{_includedir}/gc/leak_detector.h
%{_includedir}/gc.h
%{_pkgconfigdir}/bdw-gc.pc
%{_mandir}/man3/gc.3*

%files static
%defattr(644,root,root,755)
%{_libdir}/libcord.a
%{_libdir}/libgc.a

%files c++
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libgccpp.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libgccpp.so.1
%attr(755,root,root) %{_libdir}/libgctba.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libgctba.so.1

%files c++-devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libgccpp.so
%attr(755,root,root) %{_libdir}/libgctba.so
%{_libdir}/libgccpp.la
%{_libdir}/libgctba.la
%{_includedir}/gc/gc_cpp.h
%{_includedir}/gc_cpp.h

%files c++-static
%defattr(644,root,root,755)
%{_libdir}/libgccpp.a
%{_libdir}/libgctba.a
%changelog
* Wed Dec 13 2023 TLD Linux <feedback@tld-linux.org>
- For complete changelog see: http://git.tld-linux.org/?p=packages/gc.git;a=log;h=master

* Mon Oct 16 2023 Jan Palus <atler@pld-linux.org> 03a2bfc
- up to 8.2.4

* Sat Sep 17 2022 Jan Palus <atler@pld-linux.org> 7da6571
- up to 8.2.2

* Mon Feb 07 2022 Jakub Bogusz <qboosh@pld-linux.org> e1774ff
- updated to 8.2.0; introduces libgctba (C++ with throw bad::alloc) library

* Sat Dec 26 2020 Jan Palus <atler@pld-linux.org> dfad451
- don't force libatomic_ops; rel 2

* Sun Apr 28 2019 Jakub Bogusz <qboosh@pld-linux.org> d8917ad
- updated to 8.0.4

* Wed Mar 13 2019 Jan Rękorajski <baggins@pld-linux.org> e5c9c63
- release 2 (by relup.sh)

* Sat Feb 23 2019 Jakub Bogusz <qboosh@pld-linux.org> febc351
- updated to 8.0.2; atomic intrinsics are now preferred over libatomic_ops

* Sun Feb 17 2019 Jakub Bogusz <qboosh@pld-linux.org> ffcda98
- Merge remote-tracking branch 'origin/DEVEL'

* Wed Jun 28 2017 Jakub Bogusz <qboosh@pld-linux.org> c5fbd75
- updated to 7.6.0

* Sun Jul 17 2016 Jakub Bogusz <qboosh@pld-linux.org> cc0f3e5
- updated install time libatomic_ops dependency and version comment

* Sun Jul 17 2016 Jakub Bogusz <qboosh@pld-linux.org> d1890de
- updated to 7.4.4
- removed obsolete ac patch

* Sat Jul 16 2016 Jakub Bogusz <qboosh@pld-linux.org> 110ceb6
- new URLs, updated to 7.2g
- updated ac patch

* Thu Nov 12 2015 Elan Ruusamäe <glen@delfi.ee> 073f108
- move apidocs to -devel

* Tue Feb 24 2015 Jan Rękorajski <baggins@pld-linux.org> 9514b7b
- x32 rebuild
- release 2 (by relup.sh)

* Sat Nov 23 2013 Jakub Bogusz <qboosh@pld-linux.org> 446df7e
- updated to 7.2e

* Thu Apr 18 2013 Kacper Kornet <draenog@pld-linux.org> 2532eda
- up to 7.2d
- patch for automake-1.13

* Sun Sep 02 2012 Paweł Sikora <pawel.sikora@agmk.net> ebacbb8
- add missing R: atomic_ops for -devel package.

* Wed May 23 2012 Jakub Bogusz <qboosh@pld-linux.org> 307dc55
- updated to 7.2
- removed obsolete sparc patch
- added C++ interface (as -c++-* subpackages)
- needs newer libatomic_ops (with pkg-config file)

* Wed Mar 28 2012 Arkadiusz Miśkiewicz <arekm@maven.pl> e25d000
- release 2

* Wed May 28 2008 Jakub Bogusz <qboosh@pld-linux.org> f646219
- updated to 7.1
- updated sparc patch, removed obsolete malloc-segv patch

